package jpatp.multibyte;

import java.util.List;
import javax.persistence.Query;
import javax.persistence.EntityManager;
import jpa.test.client.*;


public class Client extends ClientJPABase
{

    private Query query;

    public static void main(String args[])
    {
        Client cl = new Client("em1");       
        cl.test001();
        cl.cleanup();
    }

    // constructor
    private Client(String unitname)
    {
        super(unitname);
    }
    /**
     * CLID001
     * 
     * @return
     */
     
    public boolean test001()
    {
        testStart("test001");
        try
        {
            EntityManager em = getEntityManager();
            // TP log starts
            // transaction starts
            transactionBegin();
            
            PersonEntity a = new PersonEntity(1,"NAGA");
            em.persist(a);
            PersonEntity b = new PersonEntity(2,"SATO");
            em.persist(b);
            transactionCommit();
            
            cleanup();
            em = getEntityManager();
            transactionBegin();
         
            
            // get the data from DB and initialize the list
            query = em.createNativeQuery("SELECT * FROM PERSONENTITY p ORDER BY p.id ",PersonEntity.class);
            // Compilation warning: evade no inspection cast
            List<PersonEntity> results = PersonEntities.<PersonEntity> getList(query.getResultList());

            // data update
            for(PersonEntity person : results)
            {
				System.out.println("### id = " + person.getId() + " Name = " + person.getMmmm());
                log("### id = " + person.getId() + " Name = " + person.getMmmm());
                detail("### id = " + person.getId() + " Name = " + person.getMmmm());
           }

            // commit transaction
            transactionCommit();
        }
        catch(Throwable th)
        {
            detail("Unexpected exception occured.");
            detail(th.getMessage());
            th.printStackTrace();
            failed("Unexpected exception occured.", th);
            transactionRollback();
        }
        finally
        {
            // TP log ends
            testEnd();
        }
        return true;
    }

}
